//---------------------------------------------------------------------------
#ifndef Moochos_TeenyContext_CommandsHandler_H
#define Moochos_TeenyContext_CommandsHandler_H
//---------------------------------------------------------------------------
// CommandsHandler.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moochos { namespace TeenyContext { namespace CommandsHandler {
//---------------------------------------------------------------------------
class ECommandsHandlerError : public Exception
{
public:
	__fastcall ECommandsHandlerError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TCommandsHandler : public TObject
{
private:
	void __fastcall Execute(const AnsiString& AVerb, const AnsiString& AFile, const AnsiString& AParameters, const AnsiString& ADirectory);
	void __fastcall Copy(const AnsiString& AText);
	AnsiString __fastcall GetLocation(const AnsiString& AFileName);
	AnsiString __fastcall GetNearestDir(const AnsiString& AFileName);
	AnsiString __fastcall GetDefCommandPrompt();
protected:
public:
	__fastcall TCommandsHandler();
	virtual __fastcall ~TCommandsHandler();
	void __fastcall OpenLocation(const AnsiString& AFileName);
	void __fastcall ExploreLocation(const AnsiString& AFileName);
	void __fastcall CopyFullPath(const AnsiString& AFileName);
	void __fastcall CopyRoot(const AnsiString& AFileName);
	void __fastcall CopyPath(const AnsiString& AFileName);
	void __fastcall CopyName(const AnsiString& AFileName);
	void __fastcall StartDefCommandPrompt(const AnsiString& AFileName);
	void __fastcall StartCommandCom(const AnsiString& AFileName);
	void __fastcall StartCmdExe(const AnsiString& AFileName);
};
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::TeenyContext::CommandsHandler
using namespace Moochos::TeenyContext::CommandsHandler;
//---------------------------------------------------------------------------
#endif

