//---------------------------------------------------------------------------
#ifndef Moochos_TeenyContext_FileHandler_H
#define Moochos_TeenyContext_FileHandler_H
//---------------------------------------------------------------------------
// FileHandler.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moochos { namespace TeenyContext { namespace FileHandler {
//---------------------------------------------------------------------------
class EFileHandlerError : public Exception
{
public:
	__fastcall EFileHandlerError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TFileHandler : public TObject
{
private:
	AnsiString FFileName;
	TOpenDialog* FFileDialog;
	TNotifyEvent FOnChange;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall CreateAppInstance(const AnsiString& AFileName);
	void __fastcall Execute(const AnsiString& AVerb, const AnsiString& AFile, const AnsiString& AParameters, const AnsiString& ADirectory);
	AnsiString __fastcall QuoteParameter(const AnsiString& AParameter);
	AnsiString __fastcall EnsureValidFileName(const AnsiString& AFileName);
	void __fastcall EnsureFileNameSpecified();
	void __fastcall DoChange();
	void __fastcall SetFileName(const AnsiString& AFileName);
protected:
public:
	__fastcall TFileHandler();
	virtual __fastcall ~TFileHandler();
	void __fastcall New();
	void __fastcall ChooseFile();
	void __fastcall ChooseFolder();
	void __fastcall SpecifyFiles(TStrings* AFileNames);
	void __fastcall ShowProperties();
	__property AnsiString FileName = {read=FFileName, write=SetFileName};
	__property TOpenDialog* FileDialog = {read=FFileDialog};
	__property TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::TeenyContext::FileHandler
using namespace Moochos::TeenyContext::FileHandler;
//---------------------------------------------------------------------------
#endif

