//---------------------------------------------------------------------------
// HelpHandler.cpp
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <UtilCls.h>
#include "AboutDialogUnit.h"
#include "HelpHandler.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Moochos { namespace TeenyContext { namespace HelpHandler {
//---------------------------------------------------------------------------
namespace {
//---------------------------------------------------------------------------
const AnsiString HelpFileName = ExtractFilePath(Application->ExeName) + "Help\\index.html";
//---------------------------------------------------------------------------
} // End of namespace
//---------------------------------------------------------------------------
__fastcall THelpHandler::THelpHandler() :
	TObject()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall THelpHandler::~THelpHandler()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall THelpHandler::ShowContents(bool AConfirm)
{
	if(AConfirm) {
		if(Application->MessageBox(
			AnsiString().sprintf("The program opens the file \"%s\".\r\n\r\nContinue?", HelpFileName.c_str()).c_str(),
			Application->Title.c_str(),
			MB_YESNO | MB_ICONWARNING | MB_SETFOREGROUND) != IDYES) {
			Abort();
		}
	}
	SHELLEXECUTEINFO executeInfo = {0};
	executeInfo.cbSize = sizeof(SHELLEXECUTEINFO);
	executeInfo.fMask = SEE_MASK_FLAG_NO_UI;
	executeInfo.hwnd = Application->Handle;
	executeInfo.lpFile = HelpFileName.c_str();
	executeInfo.lpParameters = NULL;
	executeInfo.lpDirectory = NULL;
	executeInfo.nShow = SW_SHOWNORMAL;
	if(!ShellExecuteEx(&executeInfo)) {
		throw EHelpHandlerError("The program cannot open the help.");
	}
}
//---------------------------------------------------------------------------
void __fastcall THelpHandler::ShowAbout()
{
	TPtr<TAboutDialog> dialog = new TAboutDialog(NULL);
	dialog->Execute();
}
//---------------------------------------------------------------------------
}}} // End of Moochos::TeenyContext::HelpHandler
//---------------------------------------------------------------------------

