//---------------------------------------------------------------------------
// TMainForm.cpp
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <UtilCls.h>
#include "Lib/Moochos/Moa/Forms.h"
#include "Lib/Moochos/Moa/Shell.h"
#include "MainFormUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm* MainForm = NULL;
//---------------------------------------------------------------------------
void __fastcall TMainForm::ActionList1Update(TBasicAction* AAction, bool& AHandled)
{
	AHandled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileNewAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	FileHandler->New();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileChooseFileAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	FileHandler->ChooseFile();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileChooseFolderAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	FileHandler->ChooseFolder();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileDropFilesAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	TPtr<TStrings> fileNames = new TStringList();
	fileNames->Assign(DroppedFiles);
	DroppedFiles->Clear();
	FileHandler->SpecifyFiles(fileNames);
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FilePropertiesAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	FileHandler->ShowProperties();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CommandsOpenLocationAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	CommandsHandler->OpenLocation(FileName);
	CommandComplete();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CommandsExploreLocationAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	CommandsHandler->ExploreLocation(FileName);
	CommandComplete();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CommandsCopyFullPathAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	CommandsHandler->CopyFullPath(FileName);
	CommandComplete();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CommandsCopyRootAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	CommandsHandler->CopyRoot(FileName);
	CommandComplete();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CommandsCopyPathAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	CommandsHandler->CopyPath(FileName);
	CommandComplete();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CommandsCopyNameAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	CommandsHandler->CopyName(FileName);
	CommandComplete();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CommandsStartDefCommandPromptAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	CommandsHandler->StartDefCommandPrompt(FileName);
	CommandComplete();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CommandsStartCommandComAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	CommandsHandler->StartCommandCom(FileName);
	CommandComplete();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CommandsStartCmdExeAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	CommandsHandler->StartCmdExe(FileName);
	CommandComplete();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::HelpShowContentsAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	HelpHandler->ShowContents(true);
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::HelpShowAboutAcExecute(TObject* ASender)
{
	TAutoScreenCursor autoScreenCursor(crHourGlass);
	HelpHandler->ShowAbout();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Initialize()
{
	try {
		Application->OnIdle = ApplicationIdle;
		DragAcceptFiles(Handle, true);
		FFileHandler = new TFileHandler();
		FileHandler->OnChange = FileHandlerChange;
		FCommandsHandler = new TCommandsHandler();
		FHelpHandler = new THelpHandler();
		FDroppedFiles = new TStringList();
		static_cast<TStringList*>(DroppedFiles)->OnChange = DroppedFilesChange;

		FileHandler->OnChange(FileHandler);
		UpdateAccess();
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Uninitialize()
{
	delete FDroppedFiles;
	FDroppedFiles = NULL;

	delete FHelpHandler;
	FHelpHandler = NULL;

	delete FCommandsHandler;
	FCommandsHandler = NULL;

	delete FFileHandler;
	FFileHandler = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ProcessParams()
{
	if(ParamCount() == 0) {
		return;
	}
	TPtr<TStrings> fileNames = new TStringList();
	for(int i = 0; i < ParamCount(); i++) {
		fileNames->Add(ParamStr(i + 1));
	}
	DroppedFiles->Assign(fileNames);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpdateCaption()
{
	if(FileHandler->FileName.Length() == 0) {
		Caption = Application->Title;
	}
	else {
		Caption = AnsiString().sprintf("%s - %s",
			ExtractFileName(FileHandler->FileName).c_str(), DefCaption.c_str());
	}
	Application->Title = Caption;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpdateTargetIcon()
{
	static const int iconWidth = 16;
	static const int iconHeight = 16;

	Image91->BoundsRect = Bounds(
		Image91->Left + (Image91->Width - iconWidth) / 2,
		Image91->Top + (Image91->Height - iconHeight) / 2,
		iconWidth,
		iconHeight);
	Image91->Picture->Icon->Handle = NULL;
	if(FileHandler->FileName.Length() == 0) {
		return;
	}
	SHFILEINFO fileInfo = {0};
	if(SHGetFileInfo(
		FileHandler->FileName.c_str(),
		0,
		&fileInfo,
		sizeof(SHFILEINFO),
		SHGFI_ICON | SHGFI_SHELLICONSIZE | SHGFI_SMALLICON) == NULL) {
		return;
	}
	Image91->Picture->Icon->Handle = fileInfo.hIcon;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpdateTargetCaption()
{
	Label91->Caption = MinimizeName(FileHandler->FileName, Label91->Canvas, Label91->ClientWidth);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpdateCurrentDir()
{
	if(FileHandler->FileName.Length() == 0) {
		return;
	}
	if(DirectoryExists(FileHandler->FileName)) {
		SetCurrentDir(FileHandler->FileName);
	}
	else {
		SetCurrentDir(ExtractFileDir(FileHandler->FileName));
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpdateAccess()
{
	const bool fileSpecified = FileHandler->FileName.Length() > 0;

	FilePropertiesAc->Enabled = fileSpecified;
	CommandsOpenLocationAc->Enabled = fileSpecified;
	CommandsExploreLocationAc->Enabled = fileSpecified;
	CommandsCopyFullPathAc->Enabled = fileSpecified;
	CommandsCopyRootAc->Enabled = fileSpecified;
	CommandsCopyPathAc->Enabled = fileSpecified;
	CommandsCopyNameAc->Enabled = fileSpecified;
	CommandsStartDefCommandPromptAc->Enabled = fileSpecified;
	CommandsStartCommandComAc->Enabled = fileSpecified;
	CommandsStartCmdExeAc->Enabled = fileSpecified;

	Label11->Enabled = BitBtn11->Enabled;
	Label12->Enabled = BitBtn12->Enabled;
	Label13->Enabled = BitBtn13->Enabled;
	Label14->Enabled = BitBtn14->Enabled;
	CheckBox91->Enabled = fileSpecified;
	CheckBox92->Enabled = fileSpecified;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CommandComplete()
{
	if(CloseOnCompletion) {
		Close();
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMDropFiles(TMessage& AMessage)
{
	TFileDrop fileDrop(AMessage);
	SetForegroundWindow(Application->Handle);
	TPtr<TStrings> fileNames = new TStringList();
	fileDrop.GetFiles(fileNames);
	fileDrop.Finish();
	DroppedFiles->Assign(fileNames);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ApplicationIdle(TObject* ASender, bool& ADone)
{
	Application->OnIdle = NULL;
	ProcessParams();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileHandlerChange(TObject* ASender)
{
	UpdateCaption();
	UpdateTargetCaption();
	UpdateTargetIcon();
	UpdateCurrentDir();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DroppedFilesChange(TObject* ASender)
{
	if(DroppedFiles->Count == 0) {
		return;
	}
	FileDropFilesAc->Execute();
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMainForm::GetFileName()
{
	AnsiString fileName = FileHandler->FileName;
	try {
		if(DereferenceLinkTarget && IsShortcutFileName(fileName)) {
			TPtr<TShellLink> shellLink = new TShellLink();
			shellLink->LoadFromFile(fileName);
			fileName = shellLink->TargetFile;
		}
	}
	catch(EShellLinkError& e) {
		throw EMainFormError(AnsiString().sprintf(
			"The program cannot read data from the shortcut file \"%s\".",
			FileHandler->FileName.c_str()));
	}
	return fileName;
}
//---------------------------------------------------------------------------
bool __fastcall TMainForm::GetDereferenceLinkTarget()
{
	return CheckBox91->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetDereferenceLinkTarget(bool ADereferenceLinkTarget)
{
	CheckBox91->Checked = ADereferenceLinkTarget;
}
//---------------------------------------------------------------------------
bool __fastcall TMainForm::GetCloseOnCompletion()
{
	return CheckBox92->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetCloseOnCompletion(bool ACloseOnCompletion)
{
	CheckBox92->Checked = ACloseOnCompletion;
}
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* AOwner) :
	TForm(AOwner),
	FFileHandler(NULL),
	FCommandsHandler(NULL),
	FHelpHandler(NULL),
	FDroppedFiles(NULL),
	FDefCaption(Application->Title)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TMainForm::~TMainForm()
{
	Uninitialize();
}
//---------------------------------------------------------------------------

