//---------------------------------------------------------------------------
#ifndef Moochos_TeenyContext_MainFormUnit_H
#define Moochos_TeenyContext_MainFormUnit_H
//---------------------------------------------------------------------------
// MainFormUnit.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <ActnList.hpp>
#include <Buttons.hpp>
#include <Classes.hpp>
#include <Controls.hpp>
#include <FileCtrl.hpp> // Must be put in the header file
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <StdCtrls.hpp>
#include "CommandsHandler.h"
#include "FileHandler.h"
#include "HelpHandler.h"
//---------------------------------------------------------------------------
class EMainFormError : public Exception
{
public:
	__fastcall EMainFormError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:
	TAction* FileNewAc;
	TAction* FileChooseFileAc;
	TAction* FileChooseFolderAc;
	TAction* FileDropFilesAc;
	TAction* FilePropertiesAc;
	TAction* CommandsOpenLocationAc;
	TAction* CommandsExploreLocationAc;
	TAction* CommandsCopyFullPathAc;
	TAction* CommandsCopyRootAc;
	TAction* CommandsCopyPathAc;
	TAction* CommandsCopyNameAc;
	TAction* CommandsStartDefCommandPromptAc;
	TAction* CommandsStartCommandComAc;
	TAction* CommandsStartCmdExeAc;
	TAction* HelpShowContentsAc;
	TAction* HelpShowAboutAc;
	TActionList* ActionList1;
	TBitBtn* BitBtn11;
	TBitBtn* BitBtn12;
	TBitBtn* BitBtn13;
	TBitBtn* BitBtn14;
	TCheckBox* CheckBox91;
	TCheckBox* CheckBox92;
	TGroupBox* GroupBox1;
	TImage* Image91;
	TLabel* Label11;
	TLabel* Label12;
	TLabel* Label13;
	TLabel* Label14;
	TLabel* Label91;
	TMenuItem* MenuItem31;
	TMenuItem* MenuItem311;
	TMenuItem* MenuItem312;
	TMenuItem* MenuItem313;
	TMenuItem* MenuItem314;
	TMenuItem* MenuItem41;
	TMenuItem* MenuItem411;
	TMenuItem* MenuItem412;
	TMenuItem* MenuItem413;
	TMenuItem* MenuItem91;
	TMenuItem* MenuItem92;
	TMenuItem* MenuItem921;
	TMenuItem* MenuItem922;
	TMenuItem* MenuItem93;
	TMenuItem* MenuItem94;
	TMenuItem* MenuItem95;
	TMenuItem* MenuItem96;
	TMenuItem* MenuItem961;
	TMenuItem* MenuItem962;
	TMenuItem* MenuItem963;
	TPopupMenu* PopupMenu3;
	TPopupMenu* PopupMenu4;
	TPopupMenu* PopupMenu9;
	TSpeedButton* SpeedButton91;
	TSpeedButton* SpeedButton92;
	void __fastcall ActionList1Update(TBasicAction* AAction, bool& AHandled);
	void __fastcall FileNewAcExecute(TObject* ASender);
	void __fastcall FileChooseFileAcExecute(TObject* ASender);
	void __fastcall FileChooseFolderAcExecute(TObject* ASender);
	void __fastcall FileDropFilesAcExecute(TObject* ASender);
	void __fastcall FilePropertiesAcExecute(TObject* ASender);
	void __fastcall CommandsOpenLocationAcExecute(TObject* ASender);
	void __fastcall CommandsExploreLocationAcExecute(TObject* ASender);
	void __fastcall CommandsCopyFullPathAcExecute(TObject* ASender);
	void __fastcall CommandsCopyRootAcExecute(TObject* ASender);
	void __fastcall CommandsCopyPathAcExecute(TObject* ASender);
	void __fastcall CommandsCopyNameAcExecute(TObject* ASender);
	void __fastcall CommandsStartDefCommandPromptAcExecute(TObject* ASender);
	void __fastcall CommandsStartCommandComAcExecute(TObject* ASender);
	void __fastcall CommandsStartCmdExeAcExecute(TObject* ASender);
	void __fastcall HelpShowContentsAcExecute(TObject* ASender);
	void __fastcall HelpShowAboutAcExecute(TObject* ASender);
private:
	TFileHandler* FFileHandler;
	TCommandsHandler* FCommandsHandler;
	THelpHandler* FHelpHandler;
	TStrings* FDroppedFiles;
	AnsiString FDefCaption;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall ProcessParams();
	void __fastcall UpdateCaption();
	void __fastcall UpdateTargetIcon();
	void __fastcall UpdateTargetCaption();
	void __fastcall UpdateCurrentDir();
	void __fastcall UpdateAccess();
	void __fastcall CommandComplete();
	void __fastcall WMDropFiles(TMessage& AMessage);
	void __fastcall ApplicationIdle(TObject* ASender, bool& ADone);
	void __fastcall FileHandlerChange(TObject* ASender);
	void __fastcall DroppedFilesChange(TObject* ASender);
	AnsiString __fastcall GetFileName();
	bool __fastcall GetDereferenceLinkTarget();
	void __fastcall SetDereferenceLinkTarget(bool ADereferenceLinkTarget);
	bool __fastcall GetCloseOnCompletion();
	void __fastcall SetCloseOnCompletion(bool ACloseOnCompletion);
protected:
public:
	virtual __fastcall TMainForm(TComponent* AOwner);
	virtual __fastcall ~TMainForm();
	BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_DROPFILES, TMessage, WMDropFiles);
	END_MESSAGE_MAP(TForm);
	__property TFileHandler* FileHandler = {read=FFileHandler};
	__property TCommandsHandler* CommandsHandler = {read=FCommandsHandler};
	__property THelpHandler* HelpHandler = {read=FHelpHandler};
	__property AnsiString FileName = {read=GetFileName};
	__property TStrings* DroppedFiles = {read=FDroppedFiles};
	__property AnsiString DefCaption = {read=FDefCaption};
	__property bool DereferenceLinkTarget = {read=GetDereferenceLinkTarget, write=SetDereferenceLinkTarget};
	__property bool CloseOnCompletion = {read=GetCloseOnCompletion, write=SetCloseOnCompletion};
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm* MainForm;
//---------------------------------------------------------------------------
#endif

